Index: /ruby/branches/0.5/lib/open_ehr/rm/data_structures/item_structure.rb
===================================================================
--- /ruby/branches/0.5/lib/open_ehr/rm/data_structures/item_structure.rb	(revision 194)
+++ /ruby/branches/0.5/lib/open_ehr/rm/data_structures/item_structure.rb	(revision 195)
@@ -32,4 +32,9 @@
           attr_accessor :items
 
+          def initialize(args = {})
+            super(args)
+            self.items = args[:items]
+          end
+
           def item_count
             unless @items.nil?
@@ -39,4 +44,25 @@
             end
           end
+
+          def names
+            return @items.collect{|item| item.name}
+          end
+
+          def named_item(a_name)
+            @items.each do |item|
+              return item if item.name.value == a_name
+            end
+            retrun nil
+          end
+
+          def ith_item(i)
+            return @items[i]
+          end
+
+          def as_hierarchy
+            return Cluster.new(:name => @name,
+                               :archetype_node_id => @archetype_node_id,
+                               :items => @items)
+          end
         end
       end # of ItemStructure
Index: /ruby/branches/0.5/lib/open_ehr/rm/data_types/basic.rb
===================================================================
--- /ruby/branches/0.5/lib/open_ehr/rm/data_types/basic.rb	(revision 194)
+++ /ruby/branches/0.5/lib/open_ehr/rm/data_types/basic.rb	(revision 195)
@@ -11,4 +11,7 @@
         class DataValue
           include OpenEhr::RM::Support::Definition::BasicDefinition
+          def ==(other)
+            return self.value == other.value
+          end
         end
 
@@ -25,4 +28,5 @@
             end
           end
+
           def value?
             @value == true
Index: /ruby/branches/0.5/lib/tasks/rspec.rake
===================================================================
--- /ruby/branches/0.5/lib/tasks/rspec.rake	(revision 195)
+++ /ruby/branches/0.5/lib/tasks/rspec.rake	(revision 195)
@@ -0,0 +1,182 @@
+gem 'test-unit', '1.2.3' if RUBY_VERSION.to_f >= 1.9
+rspec_gem_dir = nil
+Dir["#{RAILS_ROOT}/vendor/gems/*"].each do |subdir|
+  rspec_gem_dir = subdir if subdir.gsub("#{RAILS_ROOT}/vendor/gems/","") =~ /^(\w+-)?rspec-(\d+)/ && File.exist?("#{subdir}/lib/spec/rake/spectask.rb")
+end
+rspec_plugin_dir = File.expand_path(File.dirname(__FILE__) + '/../../vendor/plugins/rspec')
+
+if rspec_gem_dir && (test ?d, rspec_plugin_dir)
+  raise "\n#{'*'*50}\nYou have rspec installed in both vendor/gems and vendor/plugins\nPlease pick one and dispose of the other.\n#{'*'*50}\n\n"
+end
+
+if rspec_gem_dir
+  $LOAD_PATH.unshift("#{rspec_gem_dir}/lib")
+elsif File.exist?(rspec_plugin_dir)
+  $LOAD_PATH.unshift("#{rspec_plugin_dir}/lib")
+end
+
+# Don't load rspec if running "rake gems:*"
+unless ARGV.any? {|a| a =~ /^gems/}
+
+begin
+  require 'spec/rake/spectask'
+rescue MissingSourceFile
+  module Spec
+    module Rake
+      class SpecTask
+        def initialize(name)
+          task name do
+            # if rspec-rails is a configured gem, this will output helpful material and exit ...
+            require File.expand_path(File.dirname(__FILE__) + "/../../config/environment")
+
+            # ... otherwise, do this:
+            raise <<-MSG
+
+#{"*" * 80}
+*  You are trying to run an rspec rake task defined in
+*  #{__FILE__},
+*  but rspec can not be found in vendor/gems, vendor/plugins or system gems.
+#{"*" * 80}
+MSG
+          end
+        end
+      end
+    end
+  end
+end
+
+Rake.application.instance_variable_get('@tasks').delete('default')
+
+spec_prereq = File.exist?(File.join(RAILS_ROOT, 'config', 'database.yml')) ? "db:test:prepare" : :noop
+task :noop do
+end
+
+task :default => :spec
+task :stats => "spec:statsetup"
+
+desc "Run all specs in spec directory (excluding plugin specs)"
+Spec::Rake::SpecTask.new(:spec => spec_prereq) do |t|
+  t.spec_opts = ['--options', "\"#{RAILS_ROOT}/spec/spec.opts\""]
+  t.spec_files = FileList['spec/**/*_spec.rb']
+end
+
+namespace :spec do
+  desc "Run all specs in spec directory with RCov (excluding plugin specs)"
+  Spec::Rake::SpecTask.new(:rcov) do |t|
+    t.spec_opts = ['--options', "\"#{RAILS_ROOT}/spec/spec.opts\""]
+    t.spec_files = FileList['spec/**/*_spec.rb']
+    t.rcov = true
+    t.rcov_opts = lambda do
+      IO.readlines("#{RAILS_ROOT}/spec/rcov.opts").map {|l| l.chomp.split " "}.flatten
+    end
+  end
+
+  desc "Print Specdoc for all specs (excluding plugin specs)"
+  Spec::Rake::SpecTask.new(:doc) do |t|
+    t.spec_opts = ["--format", "specdoc", "--dry-run"]
+    t.spec_files = FileList['spec/**/*_spec.rb']
+  end
+
+  desc "Print Specdoc for all plugin examples"
+  Spec::Rake::SpecTask.new(:plugin_doc) do |t|
+    t.spec_opts = ["--format", "specdoc", "--dry-run"]
+    t.spec_files = FileList['vendor/plugins/**/spec/**/*_spec.rb'].exclude('vendor/plugins/rspec/*')
+  end
+
+  [:models, :controllers, :views, :helpers, :lib, :integration].each do |sub|
+    desc "Run the code examples in spec/#{sub}"
+    Spec::Rake::SpecTask.new(sub => spec_prereq) do |t|
+      t.spec_opts = ['--options', "\"#{RAILS_ROOT}/spec/spec.opts\""]
+      t.spec_files = FileList["spec/#{sub}/**/*_spec.rb"]
+    end
+  end
+
+  desc "Run the code examples in vendor/plugins (except RSpec's own)"
+  Spec::Rake::SpecTask.new(:plugins => spec_prereq) do |t|
+    t.spec_opts = ['--options', "\"#{RAILS_ROOT}/spec/spec.opts\""]
+    t.spec_files = FileList['vendor/plugins/**/spec/**/*_spec.rb'].exclude('vendor/plugins/rspec/*').exclude("vendor/plugins/rspec-rails/*")
+  end
+
+  namespace :plugins do
+    desc "Runs the examples for rspec_on_rails"
+    Spec::Rake::SpecTask.new(:rspec_on_rails) do |t|
+      t.spec_opts = ['--options', "\"#{RAILS_ROOT}/spec/spec.opts\""]
+      t.spec_files = FileList['vendor/plugins/rspec-rails/spec/**/*_spec.rb']
+    end
+  end
+
+  # Setup specs for stats
+  task :statsetup do
+    require 'code_statistics'
+    ::STATS_DIRECTORIES << %w(Model\ specs spec/models) if File.exist?('spec/models')
+    ::STATS_DIRECTORIES << %w(View\ specs spec/views) if File.exist?('spec/views')
+    ::STATS_DIRECTORIES << %w(Controller\ specs spec/controllers) if File.exist?('spec/controllers')
+    ::STATS_DIRECTORIES << %w(Helper\ specs spec/helpers) if File.exist?('spec/helpers')
+    ::STATS_DIRECTORIES << %w(Library\ specs spec/lib) if File.exist?('spec/lib')
+    ::STATS_DIRECTORIES << %w(Routing\ specs spec/routing) if File.exist?('spec/routing')
+    ::STATS_DIRECTORIES << %w(Integration\ specs spec/integration) if File.exist?('spec/integration')
+    ::CodeStatistics::TEST_TYPES << "Model specs" if File.exist?('spec/models')
+    ::CodeStatistics::TEST_TYPES << "View specs" if File.exist?('spec/views')
+    ::CodeStatistics::TEST_TYPES << "Controller specs" if File.exist?('spec/controllers')
+    ::CodeStatistics::TEST_TYPES << "Helper specs" if File.exist?('spec/helpers')
+    ::CodeStatistics::TEST_TYPES << "Library specs" if File.exist?('spec/lib')
+    ::CodeStatistics::TEST_TYPES << "Routing specs" if File.exist?('spec/routing')
+    ::CodeStatistics::TEST_TYPES << "Integration specs" if File.exist?('spec/integration')
+  end
+
+  namespace :db do
+    namespace :fixtures do
+      desc "Load fixtures (from spec/fixtures) into the current environment's database.  Load specific fixtures using FIXTURES=x,y. Load from subdirectory in test/fixtures using FIXTURES_DIR=z."
+      task :load => :environment do
+        ActiveRecord::Base.establish_connection(Rails.env)
+        base_dir = File.join(Rails.root, 'spec', 'fixtures')
+        fixtures_dir = ENV['FIXTURES_DIR'] ? File.join(base_dir, ENV['FIXTURES_DIR']) : base_dir
+
+        require 'active_record/fixtures'
+        (ENV['FIXTURES'] ? ENV['FIXTURES'].split(/,/).map {|f| File.join(fixtures_dir, f) } : Dir.glob(File.join(fixtures_dir, '*.{yml,csv}'))).each do |fixture_file|
+          Fixtures.create_fixtures(File.dirname(fixture_file), File.basename(fixture_file, '.*'))
+        end
+      end
+    end
+  end
+
+  namespace :server do
+    daemonized_server_pid = File.expand_path("#{RAILS_ROOT}/tmp/pids/spec_server.pid")
+
+    desc "start spec_server."
+    task :start do
+      if File.exist?(daemonized_server_pid)
+        $stderr.puts "spec_server is already running."
+      else
+        $stderr.puts %Q{Starting up spec_server ...}
+        FileUtils.mkdir_p('tmp/pids') unless test ?d, 'tmp/pids'
+        system("ruby", "script/spec_server", "--daemon", "--pid", daemonized_server_pid)
+      end
+    end
+
+    desc "stop spec_server."
+    task :stop do
+      unless File.exist?(daemonized_server_pid)
+        $stderr.puts "No server running."
+      else
+        $stderr.puts "Shutting down spec_server ..."
+        system("kill", "-s", "TERM", File.read(daemonized_server_pid).strip) &&
+        File.delete(daemonized_server_pid)
+      end
+    end
+
+    desc "restart spec_server."
+    task :restart => [:stop, :start]
+
+    desc "check if spec server is running"
+    task :status do
+      if File.exist?(daemonized_server_pid)
+        $stderr.puts %Q{spec_server is running (PID: #{File.read(daemonized_server_pid).gsub("\n","")})}
+      else
+        $stderr.puts "No server running."
+      end
+    end
+  end
+end
+
+end
Index: /ruby/branches/0.5/spec/lib/openehr/rm/data_structure/item_structure/item_list_spec.rb
===================================================================
--- /ruby/branches/0.5/spec/lib/openehr/rm/data_structure/item_structure/item_list_spec.rb	(revision 194)
+++ /ruby/branches/0.5/spec/lib/openehr/rm/data_structure/item_structure/item_list_spec.rb	(revision 195)
@@ -1,11 +1,18 @@
 require File.dirname(__FILE__) + '/../../../../../spec_helper'
 include OpenEhr::RM::DataStructures::ItemStructure
+include OpenEhr::RM::DataStructures::ItemStructure::Representation
 include OpenEhr::RM::DataTypes::Text
 
 describe ItemList do
   before(:each) do
+    items = %w{one two three}.collect do |n|
+      Element.new(:name => DvText.new(n),
+                  :archetype_node_id => 'test')
+    end
     item_list_name = DvText.new('item list')
     @item_list = ItemList.new(:name => item_list_name,
-                              :archetype_node_id => 'test')
+                              :archetype_node_id => 'test',
+                              :items => items)
+    
   end
 
@@ -14,12 +21,28 @@
   end
 
-  it 'count should be 0' do
-    @item_list.item_count.should equal 0
+  it 'count should be 3' do
+    @item_list.item_count.should be_equal 3
   end
 
-  it 'count should be change to 3' do
-    dummy_elements = [1,2,3]
-    @item_list.items = dummy_elements
-    @item_list.item_count.should equal 3
+  it 'count should be 0' do
+    @item_list.items = nil
+    @item_list.item_count.should be_equal 0
+  end
+
+
+  it 'retrieve the names of all items' do
+    @item_list.names.should == %w{one two three}.collect{|n| DvText.new(n)}
+  end
+
+  it 'retrieve the item with a name' do
+    @item_list.named_item('one').name.value.should == 'one'
+  end
+
+  it 'retrieve the ith item with number' do
+    @item_list.ith_item(1).name.value.should == 'two'
+  end
+
+  it 'generate cluster of items' do
+    @item_list.as_hierarchy.name.value.should == 'item list'
   end
 end